/**
 * @file
 * This header file declares the function to create one instance of the CV procedure.
 * The procedure is configured with a set of function pointers representing the non-default
 * actions and guards of the procedure. Some of these functions may also be declared in
 * this header file in accordance with the configuration of the procedure in the FW Profile
 * Editor. In the latter case, the user has to provide an implementation for these functions
 * in a user-supplied body file.
 *
 * This header file has been automatically generated by the FW Profile Editor.
 * The procedure created by this file is shown in the figure below.
 *
 * <b>Note for node Y2007</b>
 * Enjoyed math from an early stage!
 *
 * @image html CV.png
 *
 * @author FW Profile code generator version 5.29
 * @date Created on: Apr 15 2023 10:2:0
 */

/* Make sure to include this header file only once */
#ifndef CV_H_
#define CV_H_

/* FW Profile constant definitions */
#include "FwPrConstants.h"

/* Action node identifiers */
#define CV_Y1993 (1)		/**< The identifier of action node Y1993 in procedure CV */
#define CV_Y2007 (2)		/**< The identifier of action node Y2007 in procedure CV */
#define CV_Y2009 (3)		/**< The identifier of action node Y2009 in procedure CV */
#define CV_Y2011 (4)		/**< The identifier of action node Y2011 in procedure CV */
#define CV_Y2013 (5)		/**< The identifier of action node Y2013 in procedure CV */
#define CV_Y2015 (6)		/**< The identifier of action node Y2015 in procedure CV */
#define CV_Y2016 (7)		/**< The identifier of action node Y2016 in procedure CV */
#define CV_Y2016N17 (8)		/**< The identifier of action node Y2016N17 in procedure CV */
#define CV_Y2017 (9)		/**< The identifier of action node Y2017 in procedure CV */
#define CV_Y2018 (10)		/**< The identifier of action node Y2018 in procedure CV */
#define CV_Y2019toY2021 (11)		/**< The identifier of action node Y2019toY2021 in procedure CV */
#define CV_Y2020toY2021 (12)		/**< The identifier of action node Y2020toY2021 in procedure CV */
#define CV_Y2021 (13)		/**< The identifier of action node Y2021 in procedure CV */
#define CV_Y2022 (14)		/**< The identifier of action node Y2022 in procedure CV */
#define CV_Y2022toNow (15)		/**< The identifier of action node Y2022toNow in procedure CV */
#define CV_Y2023 (16)		/**< The identifier of action node Y2023 in procedure CV */
#define CV_Y2023toEOL (17)		/**< The identifier of action node Y2023toEOL in procedure CV */

/**
 * Create a new procedure descriptor.
 * This interface creates the procedure descriptor dynamically.
 * @param prData the pointer to the procedure data.
 * A value of NULL is legal (note that the default value of the pointer
 * to the procedure data when the procedure is created is NULL).
 * @return the pointer to the procedure descriptor
 */
FwPrDesc_t CVCreate(void* prData);

/**
 * Action for node Y2007.
 * Learned math and science in a small town in India
 * @param prDesc the procedure descriptor
 */
void MbCrTopSchool(FwPrDesc_t prDesc);

/**
 * Action for node Y2009.
 * Joined a top engineering University in India
 * @param prDesc the procedure descriptor
 */
void MbCrEnterCollege(FwPrDesc_t prDesc);

/**
 * Action for node Y2011.
 * Built a solar car from scratch and completed the World Solar Challenge in Australia
 * @param prDesc the procedure descriptor
 */
void MbCrWorldSolarChallenge(FwPrDesc_t prDesc);

/**
 * Action for node Y2013.
 * Designed aerodynamic cars at TATA Motors, one of the biggest automotive OEMs
 * @param prDesc the procedure descriptor
 */
void MbCrTataMotors(FwPrDesc_t prDesc);

/**
 * Action for node Y2015.
 * Started an EV startup
 * @param prDesc the procedure descriptor
 */
void MbCrStartEV(FwPrDesc_t prDesc);

/**
 * Action for node Y2016.
 * Received Erasmus scholarshop to pursue SpaceMaster program in Germany and Sweden
 * @param prDesc the procedure descriptor
 */
void MbCrErasmus(FwPrDesc_t prDesc);

/**
 * Action for node Y2016N17.
 * Moved to Würzburg to purse SpaceMaster (Master in Space Technology)
 * @param prDesc the procedure descriptor
 */
void MbCrSpaceMaster(FwPrDesc_t prDesc);

/**
 * Action for node Y2017.
 * Do science data processing for BEXUS
 * @param prDesc the procedure descriptor
 */
void MbCrBexus(FwPrDesc_t prDesc);

/**
 * Action for node Y2018.
 * Finished master thesis on "Heuristic Search Algorithm for Asteroid Tour Mission"
 * @param prDesc the procedure descriptor
 */
void MbCrMasterThesis(FwPrDesc_t prDesc);

/**
 * Action for node Y2019toY2021.
 * <pre>
 * Built ground station network for DLR Mission (TOM) with automated telemetry decoding (AX.25)
 * </pre>
 * @param prDesc the procedure descriptor
 */
void MbCrTOM(FwPrDesc_t prDesc);

/**
 * Action for node Y2020toY2021.
 * Developed nonlinear control algorithms for formation flying in TOM Mission
 * @param prDesc the procedure descriptor
 */
void MbCrFormationFlying(FwPrDesc_t prDesc);

/**
 * Action for node Y2021.
 * Designed Orbit for SeRANIS Satellite Mission at UniBw Munich and built orbit simulator
 * @param prDesc the procedure descriptor
 */
void MbCrSeranis(FwPrDesc_t prDesc);

/**
 * Action for node Y2022toNow.
 * Design PUS-C tailoring and TM/TC application for payload computer on SeRANIS
 * @param prDesc the procedure descriptor
 */
void MbCrObsw(FwPrDesc_t prDesc);

/**
 * Action for node Y2023.
 * Join Reflex Aerospace
 * @param prDesc the procedure descriptor
 */
void MbCrSw(FwPrDesc_t prDesc);

/**
 * Action for node Y2022.
 * Built an open source python package for PUS-C based onboard software
 * @param prDesc the procedure descriptor
 */
void MbCrPyObsw(FwPrDesc_t prDesc);

/**
 * Action for node Y2023toEOL.
 * Build more cool onboard Software
 * @param prDesc the procedure descriptor
 */
void MbCrCoolStuff(FwPrDesc_t prDesc);

/**
 * Action for node Y1993.
 * BOL
 * @param prDesc the procedure descriptor
 */
void MbBOL(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from Y2022toNow to DECISION1.
 * Apply for Software Engineering at Reflex Aerospace
 * @param prDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t IsAccepted(FwPrDesc_t prDesc);

/**
 * Guard on the Control Flow from DECISION1 to Y2023.
 * Reflex Aerospace finds my CV cool == TRUE
 * @param prDesc the procedure descriptor
 * @return 1 if the guard is fulfilled, otherwise 0.
 */
FwPrBool_t MbCrAccepted(FwPrDesc_t prDesc);

#endif /* CV_H_ */

